<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\MAN\Services;
class CampanhaFidelidade extends  \Teknisa\MAN\Controllers\TeknisaCrud{

    protected $dataSourceName        = 'select_campanha';
    protected $dataSourceCampanhas   = 'vnd84000_gerenciarCampFidelidade_campanha';
    protected $dataSourceCliente     = 'vnd84000_gerenciarCampFidelidade_cliente';
    protected $dataSourceConsumidor  = 'vnd84000_gerenciarCampFidelidade_consumidor';
    protected $dataSourceBeneDispo   = 'vnd84000_gerenciarCampFidelidade_movctr';
	protected $dataSourceBeneUtiliz  = 'vnd84000_gerenciarCampFidelidade_movcons';

	protected $parameterBagColumns = array('NRORG', 'CDCAMPANHA', 'CDCLIENTE', 'CDCONSUMIDOR');

	public function __construct ($crudService, $parameterBag, $entityManager) {
		$this->crudService 				= $crudService;
		$this->parameterBag 			= $parameterBag;
		$this->entityManager 			= $entityManager;
	}

    public function findCampFid(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'vnd84000_gerenciarCampFidelidade_campanha';
        $this->parameterBagColumns = array('NRORG', 'CDCAMPANHA', 'TCDCAMPANHA');
        
        $conditions = $request->getFilterCriteria()->getConditions();
        $conditions[2] = array(
            "columnName" => 'TCDCAMPANHA',
            "value"      => 'T',
            "operator"   => '='
        );
        
        if($conditions[1]['value'] === null) {
            $conditions[2]['value'] = 'T';
        } else {
            $conditions[2]['value'] = 'F'; 
        }
        
        $newRequest = new DTO\Request\Filter(
            new FilterCriteria(
                $request->getFilterCriteria()->getDataSourceName(),
                $conditions,
                $request->getFilterCriteria()->getPage(),
                $request->getFilterCriteria()->getPageSize()
            ),
            $request->getMethod(),
            $request->getRoutePath(),
            $request->getUserId()
        );
        
        parent::find($newRequest,$response);
    }

    public function findCampClie(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'vnd84000_gerenciarCampFidelidade_cliente';
        parent::find($request,$response);
    }

    public function findCampCons(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'vnd84000_gerenciarCampFidelidade_consumidor';
        parent::find($request,$response);
    }

    public function findBenecons(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'vnd84000_gerenciarCampFidelidade_movctr';
        parent::find($request,$response);
    }

    public function findSpendBenecons(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'vnd84000_gerenciarCampFidelidade_movcons';
        parent::find($request,$response);
    }

    public function saveCampFid(DTO\Request $request, DTO\Response $response){
        $this->dataSourceName = 'vnd84000_gerenciarCampFidelidade_campanha';
        parent::save($request,$response);
    }
}