<?php

namespace Teknisa\MAN\Factories\Retail;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class CustoComposicaoProduto extends BaseRepo {
    
    public function getCustoCompProd($CDFILIAL, $CDPRODUTO, $CDTIPOCUSTO) {
        $procedure = new StoredProcedure($this->conn, 'CUSTO_COMP_PROD');
        
        $procedure->addParam(new Param('P_CDPRODUTO', Param::PARAM_INPUT,  $CDPRODUTO, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDFILIAL',  Param::PARAM_INPUT,  $CDFILIAL,  Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_FILIPROC',  Param::PARAM_INPUT,  $CDFILIAL,  Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_TIPOCUSTO', Param::PARAM_INPUT,  $CDTIPOCUSTO, Param::PARAM_TYPE_STR)); 
        $procedure->addParam(new Param('P_QTPRODUTO', Param::PARAM_INPUT,  1,    Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param('P_LOJA',      Param::PARAM_INPUT,  null, Param::PARAM_TYPE_NULL, 50));
        $procedure->addParam(new Param('P_VRCUSTO',   Param::PARAM_OUTPUT, null, Param::PARAM_TYPE_NULL, 50));
        
        $retorno = $procedure->execute();
        
        return floatval($retorno['P_VRCUSTO']);
    }
}