<?php

namespace Teknisa\MAN\Services;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;
use \Setforms2\Shared\ORM\DateTime;

class ControleAcessoAssistant {
	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	
	public function findPermissao($CDGRUPOPER, $NRORG){
			$params = array( 
			':CDGRUPOPER'  => $CDGRUPOPER,
			':NRORG' => $NRORG
		);
		return $this->entityManager->getConnection()->fetchAll(self::SELECT_PERMISSAO, $params);
	}
	
	public function saveSupervisao($CDGRUPOPER, $NRORG){
		$params = array( 
			':CDGRUPOPER'  => $CDGRUPOPER,
			':NRORG' => $NRORG
		);
		return $this->entityManager->getConnection()->executeQuery(self::INSERT_SUPERVISOR, $params);
	}
	
	public function deleteSupervisao($CDGRUPOPER, $NRORG){
		$params = array( 
			':CDGRUPOPER'  => $CDGRUPOPER,
			':NRORG' => $NRORG
		);
		return $this->entityManager->getConnection()->executeQuery(self::DELETE_SUPERVISOR, $params);
	}
	
	const SELECT_PERMISSAO = "SELECT IDPARAMETROS, IDGESTAOSISTEM, IDCONFIGVERSAO, IDGERENSERVI, NRORG, CDGRUPOPER FROM GRUPOPER WHERE CDGRUPOPER = :CDGRUPOPER AND NRORG = :NRORG";
	
	const INSERT_SUPERVISOR =  "INSERT INTO AUTGRUPOP (CDGRUPOPER, IDAUTGRUPOP, NRAUTGRUPOP, NRORG) VALUES (:CDGRUPOPER, 'SFOS', '000', :NRORG)";
	
	const DELETE_SUPERVISOR = "DELETE FROM AUTGRUPOP WHERE CDGRUPOPER = :CDGRUPOPER AND NRORG = :NRORG";
}