<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelObservacaoCancelamentoService {
    
	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function fetchReport($conditions){
         try{
            return $this->entityManager->getConnection()->fetchAll(self::OBSERVACAO_CANCELAMENTO_QRY, $conditions);
        } catch(\Exception $e){
            throw $e;
        }
    }
    
    
    const OBSERVACAO_CANCELAMENTO_QRY = "
        SELECT VEN.CDFILIAL,  L.CDLOJA,  CX.CDCAIXA,  VEN.NRCUPOMFIS, ITC.VRUNITVENDC AS VRUNITVEND,  P.CDARVPROD ,  P.CDARVPROD||' - '||P.NMPRODUTO AS NMPRODUTO,
          'PRODUTO' AS ID, O.NMOPERADOR, ITC.DSOBSCANITE AS DESCRICAO, L.CDGRPOCORCAN,  GP.DSGRPOCOR,  L.NMLOJA,  V.NMRAZSOCVEN,
          L.CDGRPOCORCAN || ' - ' || GP.DSGRPOCOR AS CDDSGRPOCOR, VEN.CDFILIAL||' - '||F.NMFILIAL||' - Loja: '||L.CDLOJA||' - '|| L.NMLOJA AS NMFILIAL,
          VEN.CDSUPERVISOR, OP1.NMOPERADOR AS NMSUPERVISOR
        FROM  VENDA VEN
        LEFT JOIN OPERADOR OP1
         ON OP1.CDOPERADOR   = VEN.CDSUPERVISOR
          AND VEN.NRORG = OP1.NRORG
        JOIN LOJA L
         ON VEN.CDLOJA = L.CDLOJA
          AND VEN.NRORG = L.NRORG  
        JOIN CAIXA CX
         ON L.CDLOJA       = CX.CDLOJA
          AND L.CDFILIAL = CX.CDFILIAL 
          AND VEN.NRORG = CX.NRORG
        JOIN ITVENDACAN ITC
         ON VEN.CDFILIAL   = ITC.CDFILIAL
          AND VEN.CDCAIXA = ITC.CDCAIXA
          AND ITC.CDFILIAL   = L.CDFILIAL
          AND VEN.NRSEQVENDA = ITC.NRSEQVENDA
          AND CX.CDCAIXA     = ITC.CDCAIXA
          AND VEN.NRORG     = ITC.NRORG
        JOIN OPERADOR O
         ON NVL(ITC.CDOPERCANC, VEN.CDOPERADOR) = O.CDOPERADOR
          AND VEN.NRORG = O.NRORG
        JOIN PRODUTO P
         ON ITC.CDPRODUTO  = P.CDPRODUTO
          AND VEN.NRORG = P.NRORG
        LEFT JOIN GRUPOCOR GP
         ON L.CDGRPOCORCAN = GP.CDGRPOCOR
          AND VEN.NRORG = GP.NRORG
        JOIN FILIAL F
         ON VEN.CDFILIAL   = F.CDFILIAL
          AND VEN.NRORG  = F.NRORG
        LEFT JOIN VENDEDOR V
         ON VEN.CDVENDEDOR = V.CDVENDEDOR
          AND VEN.NRORG = V.NRORG  
        WHERE (INSTR( :CDFILIAL, VEN.CDFILIAL ) <> 0 OR (:TCDFILIAL  = 'T'))
          AND ((INSTR(:CDLOJA , VEN.CDFILIAL||VEN.CDLOJA) <> 0) OR (:TCDLOJA = 'T'))
          AND (VEN.DTENTRVENDA BETWEEN :DTINI AND :DTFIN)
          AND ((VEN.IDSITUVENDA  = 'C') OR (VEN.IDSITUVENDA = 'O'))
          AND VEN.NRORG  = :NRORG
          
        GROUP BY VEN.CDFILIAL, F.NMFILIAL, L.CDLOJA, CX.CDCAIXA, VEN.NRCUPOMFIS, ITC.VRUNITVENDC, P.CDARVPROD, P.NMPRODUTO, O.NMOPERADOR, ITC.DSOBSCANITE,
         L.CDGRPOCORCAN, GP.DSGRPOCOR, L.NMLOJA, V.NMRAZSOCVEN, VEN.CDSUPERVISOR, OP1.NMOPERADOR  
          
        UNION ALL
        
        SELECT VEN.CDFILIAL, L.CDLOJA, CX.CDCAIXA, VEN.NRCUPOMFIS, IT.VRUNITVEND, P.CDARVPROD, P.CDARVPROD||' - '|| P.NMPRODUTO AS NMPRODUTO, 'CUPOM' AS ID, O.NMOPERADOR,
          VEN.DSOBSCANCUP AS DESCRICAO, L.CDGRPOCORCANCUP, GP.DSGRPOCOR, L.NMLOJA, V.NMRAZSOCVEN, L.CDGRPOCORCANCUP|| ' - '|| GP.DSGRPOCOR AS CDDSGRPOCOR,
          VEN.CDFILIAL|| ' - '|| F.NMFILIAL||' - Loja: '|| L.CDLOJA|| ' - '|| L.NMLOJA|| ' - Período: '|| :DTINI|| ' a '|| :DTFIN AS NMFILIAL, VEN.CDSUPERVISOR,
          OP1.NMOPERADOR AS NMSUPERVISOR
        FROM VENDA VEN
        LEFT JOIN OPERADOR OP1
          ON OP1.CDOPERADOR   = VEN.CDSUPERVISOR
           AND VEN.NRORG = OP1.NRORG
        JOIN LOJA L 
          ON VEN.NRORG = L.NRORG
           AND VEN.CDLOJA = L.CDLOJA
        JOIN CAIXA CX
         ON VEN.NRORG = CX.NRORG
          AND L.CDLOJA = CX.CDLOJA  
          AND L.CDFILIAL = CX.CDFILIAL
        JOIN ITEMVENDA IT
         ON IT.CDFILIAL = L.CDFILIAL 
          AND IT.CDCAIXA = CX.CDCAIXA  
          AND VEN.CDFILIAL = IT.CDFILIAL  
          AND VEN.CDCAIXA  = IT.CDCAIXA
          AND VEN.NRSEQVENDA = IT.NRSEQVENDA
          AND VEN.NRORG = IT.NRORG
        JOIN OPERADOR O
         ON O.CDOPERADOR = VEN.CDOPERADOR
          AND VEN.NRORG = O.NRORG
        JOIN PRODUTO P 
          ON VEN.NRORG = P.NRORG
           AND IT.CDPRODUTO = P.CDPRODUTO
        LEFT JOIN GRUPOCOR GP
         ON L.CDGRPOCORCANCUP = GP.CDGRPOCOR
          AND VEN.NRORG = GP.NRORG
        JOIN FILIAL F
         ON VEN.CDFILIAL = F.CDFILIAL
          AND VEN.NRORG = F.NRORG
        LEFT JOIN VENDEDOR V
         ON VEN.CDVENDEDOR = V.CDVENDEDOR
          AND VEN.NRORG = V.NRORG 
        WHERE (INSTR( :CDFILIAL, VEN.CDFILIAL ) <> 0 OR (:TCDFILIAL = 'T'))
          AND ((INSTR(:CDLOJA , VEN.CDFILIAL||VEN.CDLOJA) <> 0) OR (:TCDLOJA = 'T'))
          AND (VEN.DTENTRVENDA BETWEEN :DTINI AND :DTFIN)
          AND (VEN.IDSITUVENDA = 'C')
          AND (VEN.NRORG = :NRORG)
        GROUP BY VEN.CDFILIAL, F.NMFILIAL, L.CDLOJA,  CX.CDCAIXA,  VEN.NRCUPOMFIS,  IT.VRUNITVEND,  P.CDARVPROD,  P.NMPRODUTO, O.NMOPERADOR,  VEN.DSOBSCANCUP,  L.CDGRPOCORCANCUP,
          GP.DSGRPOCOR,  L.NMLOJA,  V.NMRAZSOCVEN, VEN.CDSUPERVISOR, OP1.NMOPERADOR
        ORDER BY CDFILIAL,  CDLOJA,  CDCAIXA,  NRCUPOMFIS,  CDARVPROD
    ";
    
}